package hatelace;

/** Add immediate to address, not register */
public class Addi extends Instruction {
    private int dest_addr;
    private int src1_addr;
    private int imm;

    public Addi(int dest_addr, int src1_addr, int imm) {
        this.dest_addr = dest_addr;
        this.src1_addr = src1_addr;
        this.imm = imm;
    }

    public void execute(Memory memory, ProgramCounter PC) {
        int src1 = memory.read(this.src1_addr);
        memory.write(this.dest_addr, src1 + this.imm);
        PC.incPC();
    }

    protected String opcode() {
        return "addi";
    }

    protected Object[] operands() {
        return new Object[] {this.dest_addr, this.src1_addr, this.imm};
    }
}
