package hatelace;

public class Computer {
    private Memory memory;

    public Computer(Memory Memory) {
        this.memory = Memory;
    }

    public void load(Program program) {
        int[] instructions = program.getInstructions();
        for (int i = 0; i < instructions.length; i++) {
            this.memory.write(i, instructions[i]);
        }
    }

    public void run() {
        for(ProgramCounter PC = new ProgramCounter(); PC.getPC() < this.memory.size(); PC.incPC()) {
            int instruction = this.memory.read(PC.getPC());
            System.out.println(instruction);
        }
    }
}
