package hatelace;

public abstract class Instruction {
    public abstract void execute(Memory memory, ProgramCounter pc);

    protected abstract String opcode();

    protected abstract Object[] operands();

    @Override
    public String toString() {
        // Buffer to hold our formatted instruction
        StringBuilder sb = new StringBuilder();
        sb.append(this.opcode());

        for (Object operand : this.operands()) {
            sb.append(" ");
            sb.append(operand);
        }

        return sb.toString();
    }
}
