package hatelace;

public class Memory {
    protected int[] memory;

    public Memory() {
        this.memory = new int[1024];
    }

    public int read(int address) {
        return this.memory[address];
    }

    public int size() {
        return this.memory.length;
    }

    public void write(int address, int data) {
        if (address < 0 || address >= this.memory.length) {
            throw new IllegalArgumentException("Invalid memory address");
        }
        this.memory[address] = data;
    }

    /** Dump as IHEX-like format (see https://en.wikipedia.org/wiki/Intel_HEX) */
    public void dump() {
        for(int i = 0; i < this.memory.length; i+= 16) {
            System.out.printf(":%02X%04X00 ", 16, i);
            for(int j = 0; j < 16; j++) {
                System.out.printf("%02X ", this.memory[i + j]);
            }
            System.out.println();
        }
    }
}
